package gui;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;

import javax.swing.JTextPane;

public class SelectionTextPane extends JTextPane{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -2419560530787154014L;
	private Boolean isSelected = false;
	private int selStart, selEnd;
	


	public void paintComponent(Graphics g) {

		super.paintComponent(g);
		
		if (isSelected)
			selectLines(g);
		
	}
	
	public void setSelection(int selStart, int selEnd){
		this.selStart = selStart;
		this.selEnd = selEnd;
		isSelected = true;
		repaint();
	}
	
	public void setSelected(Boolean isSelected){
		this.isSelected = isSelected;
	}
	
	private void selectLines(Graphics g){
		
		FontMetrics fontMetrics = getFontMetrics(getFont());
		int height = fontMetrics.getHeight();
		
		g.setColor(new Color(0, 200, 0, 50));
		g.fillRect(0, selStart*height, getWidth(), (selEnd-selStart + 1)*height + (int)Math.floor(height/2));
		
	}
	

}
