package gui.common;




import java.io.File;

import logic.JavaParser;
import logic.code.CodeItem;

public class FileInfo {

	private String fileName;
	private Boolean isVisible;
	private PackageInfo parent;
	private CodeItem codeItem;
	private SyntaxEditor editor;
	private boolean visibilityChanged;
	
	public FileInfo(String fileName){
		
		this.fileName = fileName;
		isVisible = true;
		
		File file = new File(getAbsoluteFileName());
		JavaParser parser = new JavaParser(file);
		codeItem = parser.getCodeItem();
		editor = new SyntaxEditor(file.getName());
		editor.setText(parser.getSourceCode());
	}
	
	public void visible(Boolean isVisible){
		this.isVisible = isVisible;
		visibilityChanged = true;
	}
	
	public Boolean isVisible(){
		return isVisible;
	}
	
	public boolean visibilityChanged() {
		boolean temp = visibilityChanged;
		visibilityChanged = false;
		return temp;
	}
	
	public String getAbsoluteFileName(){
		return fileName;
	}
	
	public String getName(){
		File file = new File(fileName);
		return file.getName();
	}
	
	public void setParent(PackageInfo parent){
		this.parent = parent;
	}
	
	public PackageInfo getParent(){
		return parent;
	}
	
	public CodeItem getCodeItem() {
		return codeItem;
	}
	
	
	public SyntaxEditor getEditor(){
		return editor;
	}

	public void refreshItem() {
		File file = new File(fileName);
		JavaParser parser = new JavaParser(file);
		codeItem = parser.getCodeItem();
	}
}
