package gui.common;

import java.util.LinkedList;

public class PackageInfo {
	
	private String name;
	private int activeFileInfo = 0;
	private LinkedList<FileInfo> files;
	
	public PackageInfo(String name){
		this.name = name;
		files = new LinkedList<FileInfo>();
		activeFileInfo = 0;
	}
	
	public void add(FileInfo fileInfo){
		files.add(fileInfo);
		
		fileInfo.setParent(this);
	}
	
	public LinkedList<FileInfo> getFiles(){
		return files;
	}
	
	public String getName(){
		return name;
	}
	
	public void setActiveFileInfoIndex(int index){
		activeFileInfo = index;
	}
	
	public int getAtiveFileInfoIndex(){
		return activeFileInfo;
	}
	
	public FileInfo getActiveFileInfo(){
		return files.get(activeFileInfo);
	}
	
	public int numFiles() {
		return files.size();
	}
	
	public FileInfo getFileInfo(String name){
		
		FileInfo result = null;
		
		for (int i = 0; i < files.size(); i++){
			if (files.get(i).getAbsoluteFileName().equals(name)){
				result = files.get(i);
				break;
			}
		}
		
		return result;
	}
	
	public int getIndexOfFileInfo(String name){
		
		
		for (int i = 0; i < files.size(); i++){
			if (files.get(i).getAbsoluteFileName().equals(name)){
				return i;
			}
		}
		
		return -1;
	}
}

