package gui.common;

import java.awt.BorderLayout;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;

import gui.EditorPanel;
import gui.SelectionTextPane;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.Element;

public class SyntaxEditor extends JScrollPane implements DocumentListener, FocusListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = 7492893766190613230L;
	
	private String name;
	private SelectionTextPane textPane;
	private Boolean unsavedChanges = false;
	public static int startline;
	private int caretLinePosition = 0;
	
	public SyntaxEditor(String name){

		this.name = name;
		
		JPanel dummyPanel = new JPanel(new BorderLayout());
		
		textPane = new SelectionTextPane();
		textPane.setEditorKit(new SyntaxHighlightingKit());
		
		dummyPanel.add(textPane);
		setViewportView(dummyPanel);
		
		CaretListener listener = new CaretListener(){
			 public void caretUpdate(CaretEvent caretEvent) {
			    	
			    	int caretPosition = textPane.getCaretPosition();
					Element root = textPane.getDocument().getDefaultRootElement();
					EditorPanel.lineNumberChanged((root.getElementIndex(caretPosition) + 1));
					caretLinePosition = root.getElementIndex(caretPosition) + 1;
			      }

		};
		textPane.addCaretListener(listener);
		textPane.addFocusListener(this);		// enable/disable show Statement button

		textPane.updateUI();
	}
	
	public void setText(String text){
		textPane.setText(text);	
		textPane.getDocument().addDocumentListener(this);
	}
	
	public SelectionTextPane getTextPane(){
		return textPane;
	}
	
	public int getCaretLinePosition(){
		return caretLinePosition;
	}
	
	public void markLines(int firstLine, int lastLine){
		
		textPane.setSelectionStart(0);
		textPane.setSelectionStart(10);
	}
	
	public String getTitle(){
		if (unsavedChanges)
			return "*" + name;
		else
			return name;
	}

	public void changedUpdate(DocumentEvent arg0) {
		if (!unsavedChanges){
			unsavedChanges = true;
			EditorPanel.titleChange(this);
		}
	}

	public void insertUpdate(DocumentEvent arg0) {
	}

	public void removeUpdate(DocumentEvent arg0) {
	}

	
	@Override
	public void focusGained(FocusEvent fe) {
		EditorPanel.showItemButtonEnabled(true);
	}

	@Override
	public void focusLost(FocusEvent fe) {
	}
	
	public void save(){
		unsavedChanges = false;
		EditorPanel.titleChange(this);
	}


}

class SyntaxCaretListener implements CaretListener{
	
//	private SyntaxEditor syntaxEditor;
	
	public SyntaxCaretListener(){
		super();
	}
    public void caretUpdate(CaretEvent caretEvent) {
    	
//    	int caretPosition = syntaxEditor.getTextPane().getCaretPosition();
//		Element root = syntaxEditor.getTextPane().getDocument().getDefaultRootElement();	
      }
}

