package gui.filters;

import java.io.File;
import java.util.regex.Pattern;

public class PngFilter extends SaveFilter {
		
	private static Pattern p;
	
	static {
		 p = Pattern.compile(".png$");
		 
	}
	
	public boolean accept(File file) {
    
		if (file.isDirectory()) 
			return true;
		
		return p.matcher(file.getName()).find();
	}
	
	public File addExtension(File file) {
		
		String filename = file.getAbsolutePath();
		
		if (!p.matcher(filename).find())
			filename += ".png";
		
		return new File(filename);
	}
    
	public String getDescription() {
		return "PNG Files (*.png)";
	}
  
  
}
