package opengl.common;

import logic.TimeMachine;

public class FadeEffect {
	
	private int itemID;
	private int currentTrans;
	private boolean fadeIn;
	private TimeMachine duration;
	private float speed = 0.006f;
	
	public FadeEffect(int itemID, boolean fadeIn) {
		this.itemID = itemID;
		this.fadeIn = fadeIn;
		duration = new TimeMachine();
		currentTrans = (fadeIn) ? 1 : 254;
	}

	public FadeEffect(int itemID) {
		
		this.itemID = itemID;
		this.fadeIn = true;
		duration = new TimeMachine();
		currentTrans = (fadeIn) ? 1 : 254;
	}
	
	public FadeEffect(int itemID, boolean fadeIn, float speed) {
		this.itemID = itemID;
		this.fadeIn = fadeIn;
		this.speed = speed;
		
		duration = new TimeMachine();
		currentTrans = (fadeIn) ? 1 : 254;
		
	}
	
	public FadeEffect(int itemID, boolean fadeIn, float speed, float min) {
		this.itemID = itemID;
		this.fadeIn = fadeIn;
		this.speed = speed;
		
		duration = new TimeMachine();
		currentTrans = (fadeIn) ? Math.round(min*255)+1 : 254;
		
	}
	
	public int getDuration() {
		return duration.elapsedSec();
	}
	
	public int getItemID() {
		return itemID;
	}
	
	public float getNormAlpha() {
		
		return (float)getAlpha()/255.0f;
	}
	
	
	public int getAlpha() {
		
		if (currentTrans == 0 || currentTrans == 255)
			return currentTrans;
		
		int sign = (fadeIn)? 1 : -1;
		float time = (float)duration.elapsedMilliSec();
		float alpha = currentTrans;
		alpha += sign*time*speed;
		currentTrans = Math.round(alpha);
		
		if (currentTrans < 0)
			currentTrans = 0;
		else if (currentTrans > 255)
			currentTrans = 255;
		return currentTrans;
	}
	
	public boolean isFadeIn() {
		return fadeIn;
	}
	
}
