package opengl.common;

import gui.GuiMain;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.nio.ByteBuffer;

import javax.media.opengl.GL;
import javax.swing.JOptionPane;


public class ImageSaver{

	public static void writeScreenshot(GL gl, File newImgFile, int width, int height){
		
		ByteBuffer buffer = ByteBuffer.allocateDirect(width * height * 3 );
		gl.glReadBuffer( GL.GL_BACK );
	    gl.glPixelStorei( GL.GL_PACK_ALIGNMENT, 1 );
	    gl.glReadPixels( 0, 0, width, height, GL.GL_RGB, GL.GL_UNSIGNED_BYTE, buffer);
	    
	    
	    
	    int[] pixelInts = new int[width * height];
	    int p = width * height * 3; 
	    int q; 
	    int i = 0;
	    int w3 = width * 3;
	    
	    for (int row = 0; row < height; row++) {
	    	p -= w3;
	    	q = p;
	    	for (int col = 0; col < width; col++) {
	    		int iR = buffer.get(q++);
	    		int iG = buffer.get(q++);
	    		int iB = buffer.get(q++);
	    		pixelInts[i++] = 0xFF000000 | ((iR & 0x000000FF) << 16) | ((iG & 0x000000FF) << 8) | (iB & 0x000000FF);
	    	}
	    }
	      
	    BufferedImage img = 
	    new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
	    img.setRGB(0, 0, width, height, pixelInts, 0, width);
	    
	    String imgCoding = "PNG";
		if(newImgFile.getName().contains(".jpg"))
			imgCoding = "JPG";
		
	    try {
	    	javax.imageio.ImageIO.write(img, imgCoding, newImgFile);
	    } 
	    catch (IOException e) {
	    	JOptionPane.showMessageDialog(GuiMain.getMainFrame(), "Could'nt write File. We apologize.", "Error", JOptionPane.OK_OPTION);
	    	e.printStackTrace();
	    }
	}
}
