package opengl.geometry;

import java.awt.Color;

public class Vec2 {
	
	private int x, y;
	private Color col;
	
	public Vec2() {
		x = 0;
		y = 0;
		col = new Color(0.0f, 0.0f, 0.0f);
	}
	
	public Vec2(int[] coords) {
		x = coords[0];
		y = coords[1];
		col = new Color(0.0f, 0.0f, 0.0f);
	}
	
	public Vec2(int[] coords, Color col){
		x = coords[0];
		y = coords[1];
		this.col = col;
	}
	
	public Vec2(int x, int y) {
		
		this.x = x;
		this.y = y;
		this.col = new Color(0.0f, 0.0f, 0.0f);
	}
	
	public Vec2(int x, int y, Color col) {
		
		this.x = x;
		this.y = y;
		this.col = new Color(0.0f, 0.0f, 0.0f);
	}
	
	public Vec2(Vec2 vec) {
		this.x = vec.getX();
		this.y = vec.getY();
		this.col = vec.getColor();
	}
	
	public void setX(int x) {
		this.x = x;
	}
	
	public void setY(int y) {
		this.y = y;
	}

	public void setColor(Color col) {
		this.col = col;
	}

	public int getX() {
		return x;
	}
	
	public int getY() {
		return y;
	}
	
	public Color getColor() {
		return col;
	}

	public Vec2 add(Vec2 vec) {
		x += vec.getX();
		y += vec.getY();
		
		return this;
	}
	
	public void printStd() {
		System.out.println(" x: " + x + " y: " + y + " color: " +
				col.getRed() + " " + col.getGreen() + " " + col.getBlue());
	}
	
	public float sqLength() {
		return x*x+y*y;
	}
	
	public float length() {
		return (float)Math.sqrt(sqLength());
	}
	
	public float distance(Vec2 vec) {
		Vec2 diff = new Vec2(this.x-vec.x,
				this.y-vec.y);
		return diff.length();
	}
	
	public int[] toArray() {
		int[] array = {x, y};
		return array;
	}
}
